#ifndef __CALLBACK_H
#define __CALLBACK_H

#include <sets.h>
#include <queues.h>

const int InstanceCodeSize = 16;
const int NoOfInstances = 256;

#define POP_AX		0x58
#define POP_BX		0x5B
#define PUSH		0x68
#define PUSH_BX	0x53
#define PUSH_AX	0x50
#define FAR_JMP	0xEA

#if         defined(__COMPACT__)
#error   Object Callback cannot be built in Compact model.
#endif

#if         defined(__TINY__)
#error   Object Callback cannot be built in Tiny model.
#endif

#if defined(__HUGE__) || defined(__LARGE__)
const int ThisSEG = 3;
const int ThisOFF = 6;
const int fpPtrSEG = 11;
#else
const int ThisSEG = 3;
const int fpPtrSEG = 8;
#endif

extern "C" UINT WINAPI AllocCStoDSAlias (UINT);

typedef BI_SetAsVector<FARPROC> CallListTyp;
typedef BI_QueueAsDoubleList<FARPROC> FreeListTyp;
typedef void (far pascal Object::*CallObjTyp)();

_CLASSDEF(ObjectCallBack)
class _CLASSTYPE ObjectCallBack
{
private :
	FARPROC WINAPI MakeProcInstance (FARPROC lfpPtr,PCObject pThis);
public:
	ObjectCallBack ();
	~ObjectCallBack ();
	FARPROC WINAPI FreeProcInstance (FARPROC lpfPtr);
	FARPROC WINAPI MakeProcInstance (CallObjTyp CallObjPtr,PCObject pThis);
private:
	HGLOBAL 	hCode;
	void far *vfpCode;
	FreeListTyp *pFreeList;
	CallListTyp	*pCallList;
	BOOL		Status;
};

#endif
